Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoTimesExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoTimesExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DoTimesExpressions.cs	(revision 14513)
@@ -1,102 +1,60 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
-using HeuristicLab.Common;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class DoTimesExpression : LoopExpression
-    {
-        public DoTimesExpression()
-        { }
-
-        public DoTimesExpression(LoopExpression origin, Cloner cloner) : base(origin, cloner)
-        { }
-
-        protected override bool HasInsufficientArguments(IInterpreter interpreter, IStack<Expression> sourceStack)
-        {
-            return interpreter.IntegerStack.Count < 1 ||
-                   sourceStack.Count == 0 ||
-                   interpreter.IntegerStack.Top <= 0;
-        }
-
-        protected override void InitState(IInterpreter interpreter, IStack<Expression> sourceStack)
-        {
-            body = sourceStack.Pop();
-            destinationIndex = interpreter.IntegerStack.Pop();
-            currentIndex = 1;
-            incrementor = 1;
-        }
-
-        protected override void PushIteration(IInterpreter interpreter)
-        {
-            interpreter.ExecStack.Push(this, body);
-        }
-
-        protected override void PushLastIteration(IInterpreter interpreter)
-        {
-            interpreter.ExecStack.Push(body);
-        }
+  public abstract class DoTimesExpression : LoopExpression {
+    protected override bool HasInsufficientArguments(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
+      return (interpreter.IntegerStack.Count < 1) || (sourceStack.Count == 0) || (interpreter.IntegerStack.Top <= 0);
     }
 
-    /// <summary>
-    /// Like CODE.DO*COUNT but does not push the loop counter.
-    /// This should be implemented as a macro that expands into CODE.DO*RANGE, similarly to the implementation
-    /// of CODE.DO*COUNT, except that a call to INTEGER.POP should be tacked on to the front of the loop body code
-    /// in the call to CODE.DO*RANGE.
-    /// </summary>
-
-    public class CodeDoTimesExpression : DoTimesExpression
-    {
-        public CodeDoTimesExpression()
-        { }
-
-        protected CodeDoTimesExpression(CodeDoTimesExpression origin, Cloner cloner) : base(origin, cloner)
-        { }
-
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new CodeDoTimesExpression(this, cloner);
-        }
-
-        protected override string InitStringRepresentation()
-        {
-            return "CODE.DO*TIMES";
-        }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter, interpreter.CodeStack);
-        }
+    protected override void InitState(IPushGpInterpreter interpreter, IStack<Expression> sourceStack) {
+      this.State.Body = sourceStack.Pop();
+      this.State.DestinationIndex = interpreter.IntegerStack.Pop();
+      this.State.CurrentIndex = 1;
+      this.State.Incrementor = 1;
     }
 
-    /// <summary>
-    /// Like EXEC.DO*COUNT but does not push the loop counter. This should be implemented as a macro that expands into EXEC.DO*RANGE,
-    /// similarly to the implementation of EXEC.DO*COUNT, except that a call to INTEGER.POP should be tacked on to the front of the
-    /// loop body code in the call to EXEC.DO*RANGE. This call to INTEGER.POP will remove the loop counter, which will have been
-    /// pushed by EXEC.DO*RANGE, prior to the execution of the loop body.
-    /// </summary>
+    protected override void PushIteration(IPushGpInterpreter interpreter) {
+      interpreter.ExecStack.Push(this, this.State.Body);
+    }
 
-    public class ExecDoTimesExpression : DoTimesExpression
-    {
-        public ExecDoTimesExpression()
-        { }
+    protected override void PushLastIteration(IPushGpInterpreter interpreter) {
+      interpreter.ExecStack.Push(this.State.Body);
+    }
+  }
 
-        protected ExecDoTimesExpression(ExecDoTimesExpression origin, Cloner cloner) : base(origin, cloner)
-        { }
+  /// <summary>
+  ///     Like CODE.DO*COUNT but does not push the loop counter.
+  ///     This should be implemented as a macro that expands into CODE.DO*RANGE, similarly to the implementation
+  ///     of CODE.DO*COUNT, except that a call to INTEGER.POP should be tacked on to the front of the loop body code
+  ///     in the call to CODE.DO*RANGE.
+  /// </summary>
+  public class CodeDoTimesExpression : DoTimesExpression {
+    protected override string InitStringRepresentation() {
+      return "CODE.DO*TIMES";
+    }
 
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new ExecDoTimesExpression(this, cloner);
-        }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter, interpreter.CodeStack);
+    }
+  }
 
-        protected override string InitStringRepresentation()
-        {
-            return "EXEC.DO*TIMES";
-        }
+  /// <summary>
+  ///     Like EXEC.DO*COUNT but does not push the loop counter. This should be implemented as a macro that expands into
+  ///     EXEC.DO*RANGE,
+  ///     similarly to the implementation of EXEC.DO*COUNT, except that a call to INTEGER.POP should be tacked on to the
+  ///     front of the
+  ///     loop body code in the call to EXEC.DO*RANGE. This call to INTEGER.POP will remove the loop counter, which will have
+  ///     been
+  ///     pushed by EXEC.DO*RANGE, prior to the execution of the loop body.
+  /// </summary>
+  public class ExecDoTimesExpression : DoTimesExpression {
+    protected override string InitStringRepresentation() {
+      return "EXEC.DO*TIMES";
+    }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter, interpreter.ExecStack);
-        }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter, interpreter.ExecStack);
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DuplicateExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/DuplicateExpressions.cs	(revision 14513)
@@ -1,81 +1,107 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    /// <summary>
-    /// Duplicates the top item on the INTEGER stack. Does not pop its argument
-    /// (which, if it did, would negate the effect of the duplication!).
-    /// </summary>
-    /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class DuplicateExpression<T> : StatelessExpression
+  /// <summary>
+  ///     Duplicates the top item on the INTEGER stack. Does not pop its argument
+  ///     (which, if it did, would negate the effect of the duplication!).
+  /// </summary>
+  /// <typeparam name="T">Stacktype</typeparam>
+  public abstract class DuplicateExpression<T> : StatelessExpression
+  {
+    protected void Eval(IStack<T> stack)
     {
-        public void Eval(IStack<T> stack)
-        {
-            if (stack.Count == 0)
-                return;
+      if (stack.Count == 0) return;
 
-            stack.Push(stack.Top);
-        }
+      stack.Push(stack.Top);
     }
 
-    public class IntegerDuplicateExpression : DuplicateExpression<long>
+    protected void Eval(IStack<Expression> stack)
     {
-        protected override string InitStringRepresentation() { return "INTEGER.DUP"; }
+      if (stack.Count == 0) return;
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack);
-        }
+      var top = stack.Top;
+
+      stack.Push(top);
+    }
+  }
+
+  public class IntegerDuplicateExpression : DuplicateExpression<long>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "INTEGER.DUP";
     }
 
-    public class FloatDuplicateExpression : DuplicateExpression<double>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "FLOAT.DUP"; }
+      this.Eval(interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack);
-        }
+  public class FloatDuplicateExpression : DuplicateExpression<double>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "FLOAT.DUP";
     }
 
-    public class BooleanDuplicateExpression : DuplicateExpression<bool>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "BOOLEAN.DUP"; }
+      this.Eval(interpreter.FloatStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack);
-        }
+  public class BooleanDuplicateExpression : DuplicateExpression<bool>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "BOOLEAN.DUP";
     }
 
-    public class NameDuplicateExpression : DuplicateExpression<string>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "NAME.DUP"; }
+      this.Eval(interpreter.BooleanStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack);
-        }
+  public class NameDuplicateExpression : DuplicateExpression<string>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "NAME.DUP";
     }
 
-    public class ExecDuplicateExpression : DuplicateExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "EXEC.DUP"; }
+      this.Eval(interpreter.NameStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.ExecStack);
-        }
+  public class ExecDuplicateExpression : DuplicateExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "EXEC.DUP";
     }
 
-    public class CodeDuplicateExpression : DuplicateExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "CODE.DUP"; }
+      this.Eval(interpreter.ExecStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.CodeStack);
-        }
+  public class CodeDuplicateExpression : DuplicateExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "CODE.DUP";
     }
+
+    public override void Eval(IPushGpInterpreter interpreter)
+    {
+      this.Eval(interpreter.CodeStack);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ERCExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ERCExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ERCExpressions.cs	(revision 14513)
@@ -1,104 +1,52 @@
-﻿using System;
-using HeuristicLab.Algorithms.PushGP.Generators;
-using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Random;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using HeuristicLab.Algorithms.PushGP.Generators;
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class ERCExpression<T> : Expression
-    {
-        private readonly T value;
+  /// <summary>
+  /// ERC expressions are only used for code generation.
+  /// </summary>
+  /// <typeparam name="T"></typeparam>
+  public abstract class ErcExpression<T> : PushExpression<T> {
+    protected ErcExpression(T value) : base(value) { }
 
-        public ERCExpression(T value)
-        {
-            this.value = value;
-        }
-
-        protected void Eval(IStack<T> stack)
-        {
-            stack.Push(value);
-        }
-
-        /// <summary>
-        /// Does not make sense
-        /// </summary>
-        /// <returns></returns>
-        protected override string InitStringRepresentation()
-        {
-            throw new NotImplementedException();
-        }
-
-        /// <summary>
-        /// Does not make sense
-        /// </summary>
-        /// <returns></returns>
-        protected override int InitId()
-        {
-            throw new NotImplementedException();
-        }
-
-        /// <summary>
-        /// Does not make sense
-        /// </summary>
-        /// <returns></returns>
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            throw new NotImplementedException();
-        }
+    protected override string InitStringRepresentation() {
+      return string.Format("{0}({1})", this.GetType().Name, this.State);
     }
 
-    public class IntegerERCExpression : ERCExpression<long>
-    {
-        public IntegerERCExpression() : base(IntegerGenerator.RandomInteger())
-        {
-        }
+    protected override int InitId() {
+      return this.State.GetHashCode();
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack);
-        }
+  public class IntegerErcExpression : ErcExpression<long> {
+    public IntegerErcExpression() : base(IntegerGenerator.RandomInteger()) { }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.IntegerStack);
     }
+  }
 
-    public class FloatERCExpression : ERCExpression<double>
-    {
-        protected bool isInitialized = false;
+  public class FloatErcExpression : ErcExpression<double> {
+    public FloatErcExpression() : base(FloatGenerator.RandomFloat()) { }
 
-        public FloatERCExpression() : base(FloatGenerator.RandomFloat())
-        {
-        }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.FloatStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack);
-        }
+  public class BooleanErcExpression : ErcExpression<bool> {
+    public BooleanErcExpression() : base(BooleanGenerator.RandomBoolean()) { }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.BooleanStack);
     }
+  }
 
-    public class BooleanERCExpression : ERCExpression<bool>
-    {
-        public BooleanERCExpression() : base(BooleanGenerator.RandomBoolean())
-        {
-        }
+  public class NameErcExpression : ErcExpression<string> {
+    public NameErcExpression() : base(NameGenerator.RandomName()) { }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack);
-        }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.NameStack);
     }
-
-    public class NameERCExpression : ERCExpression<string>
-    {
-        private static IRandom random = new FastRandom();
-
-        public NameERCExpression() : base(NameGenerator.RandomName())
-        {
-        }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack);
-        }
-    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/EqualsExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/EqualsExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/EqualsExpressions.cs	(revision 14513)
@@ -1,82 +1,99 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    /// <summary>
-    /// Pushes TRUE onto the BOOLEAN stack if the top two items are equal, or FALSE otherwise
-    /// </summary>
-    /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class EqualsExpression<T> : StatelessExpression
+  /// <summary>
+  ///     Pushes TRUE onto the BOOLEAN stack if the top two items are equal, or FALSE otherwise
+  /// </summary>
+  /// <typeparam name="T">Stacktype</typeparam>
+  public abstract class EqualsExpression<T> : StatelessExpression
+  {
+    public void Eval(IStack<T> stack, IStack<bool> booleanStack)
     {
-        public void Eval(IStack<T> stack, IStack<bool> booleanStack)
-        {
-            if (stack.Count < 2)
-                return;
+      if (stack.Count < 2) return;
 
-            var items = stack.Pop(2);
+      var items = stack.Pop(2);
 
-            booleanStack.Push(items[0].Equals(items[1]));
-        }
+      booleanStack.Push(items[0].Equals(items[1]));
+    }
+  }
+
+  public class IntegerEqualsExpression : EqualsExpression<long>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "INTEGER.=";
     }
 
-    public class IntegerEqualsExpression : EqualsExpression<long>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "INTEGER.="; }
+      this.Eval(interpreter.IntegerStack, interpreter.BooleanStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack, interpreter.BooleanStack);
-        }
+  public class FloatEqualsExpression : EqualsExpression<double>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "FLOAT.=";
     }
 
-    public class FloatEqualsExpression : EqualsExpression<double>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "FLOAT.="; }
+      this.Eval(interpreter.FloatStack, interpreter.BooleanStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack, interpreter.BooleanStack);
-        }
+  public class BooleanEqualsExpression : EqualsExpression<bool>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "BOOLEAN.=";
     }
 
-    public class BooleanEqualsExpression : EqualsExpression<bool>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "BOOLEAN.="; }
+      this.Eval(interpreter.BooleanStack, interpreter.BooleanStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack, interpreter.BooleanStack);
-        }
+  public class NameEqualsExpression : EqualsExpression<string>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "NAME.=";
     }
 
-    public class NameEqualsExpression : EqualsExpression<string>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "NAME.="; }
+      this.Eval(interpreter.NameStack, interpreter.BooleanStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack, interpreter.BooleanStack);
-        }
+  public class ExecEqualsExpression : EqualsExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "EXEC.=";
     }
 
-    public class ExecEqualsExpression : EqualsExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "EXEC.="; }
+      this.Eval(interpreter.ExecStack, interpreter.BooleanStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.ExecStack, interpreter.BooleanStack);
-        }
+  public class CodeEqualsExpression : EqualsExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "CODE.=";
     }
 
-    public class CodeEqualsExpression : EqualsExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "CODE.="; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.CodeStack, interpreter.BooleanStack);
-        }
+      this.Eval(interpreter.CodeStack, interpreter.BooleanStack);
     }
+  }
 }
